---
title: MediaStreamTrack.stop()
slug: Web/API/MediaStreamTrack/stop
tags:
  - API
  - Media
  - Media Capture and Streams API
  - Media Streams API
  - MediaStreamTrack
  - Method
  - Reference
  - Streams
  - WebRTC
  - stop
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p>The<strong> </strong><code><strong>MediaStreamTrack.stop()</strong></code><strong> </strong>method stops the track.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>track</em>.stop()
</pre>

<h2 id="Description">Description</h2>

<p>Calling <code>stop()</code> tells the {{glossary("user agent")}} that the track's source—whatever that source may be, including files, network streams, or a local camera or microphone—is no longer needed by the {{domxref("MediaStreamTrack")}}. Since multiple tracks may use the same source (for example, if two tabs are using the device's microphone), the source itself isn't necessarily immediately stopped. It is instead disassociated from the track and the track object is stopped. Once no media tracks are using the source, the source may actually be completely stopped.</p>

<p>Immediately after calling <code>stop()</code>, the {{domxref("MediaStreamTrack.readyState", "readyState")}} property is set to <code>ended</code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Stopping_a_video_stream">Stopping a video stream</h3>

<p>In this example, we see a function which stops a streamed video by calling <code>stop()</code> on every track on a given {{HTMLElement("video")}}.</p>

<pre class="brush: js">function stopStreamedVideo(videoElem) {
  const stream = videoElem.srcObject;
  const tracks = stream.getTracks();

  tracks.forEach(function(track) {
    track.stop();
  });

  videoElem.srcObject = null;
}</pre>

<p>This works by obtaining the video element's stream from its {{domxref("HTMLMediaElement.srcObject", "srcObject")}} property. Then the stream's track list is obtained by calling its {{domxref("MediaStream.getTracks", "getTracks()")}} method. From there, all that remains to do is to iterate over the track list using {{jsxref("Array.forEach", "forEach()")}} and calling each track's <code>stop()</code> method.</p>

<p>Finally, <code>srcObject</code> is set to <code>null</code> to sever the link to the {{domxref("MediaStream")}} object so it can be released.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Media Capture', '#dom-mediastreamtrack-stop', 'MediaStreamTrack.stop()') }}</td>
   <td>{{ Spec2('Media Capture') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaStreamTrack.stop")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("MediaStreamTrack")}}, the interface it belongs to.</li>
 <li>{{domxref("MediaStreamTrack.readyState")}}</li>
 <li>{{event("ended")}}</li>
</ul>
